/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.engine.io;

import java.io.Closeable;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.FileStore;
import java.nio.file.Files;
import java.util.zip.GZIPOutputStream;

import com.codahale.metrics.Counter;
import com.google.common.io.CountingOutputStream;

import it.geosolutions.io.output.FastBufferedOutputStream;
import lombok.Getter;
import nz.org.riskscape.engine.Tuple;

/**
 * Wraps a {@link DataOutputStreamTupleWriter} to write out to a buffered and byte counted {@link FileOutputStream}.
 */
public class DiskStorageWriter implements TupleWriter, Closeable {

  public static final int BUFFER_SIZE = 2000000;
  public static final long OUT_OF_DISK_THRESHOLD_BYTES = 1024;

  @Getter
  private final File file;
  private final OutputStream buffer;
  private final CountingOutputStream counter;
  private final DataOutputStreamTupleWriter writer;
  private final Counter metricsCounter;

  public DiskStorageWriter(File file, boolean compressed) throws IOException {
    this(file, compressed, null);
  }

  public DiskStorageWriter(File file, boolean compressed, Counter metricsCounter) throws IOException {
    this.file = file;
    this.metricsCounter = metricsCounter;

    FileOutputStream fos = new FileOutputStream(file);
    if (compressed) {
      this.buffer = new GZIPOutputStream(fos, BUFFER_SIZE, false);
    } else {
      this.buffer = new FastBufferedOutputStream(fos);
    }
    this.counter = new CountingOutputStream(buffer);
    this.writer = new DataOutputStreamTupleWriter(new DataOutputStream(counter));
  }

  @Override
  public void write(Tuple tuple) throws IOException {
    try {
      long start = counter.getCount();
      writer.write(tuple);
      long delta = counter.getCount() - start;
      if (metricsCounter != null) {
        metricsCounter.inc(delta);
      }
    } catch (IOException e) {
      maybeRaiseDiskSpaceException(e);
      throw e;
    }
  }

  private void maybeRaiseDiskSpaceException(IOException e) throws IOException {
    FileStore fileStore = Files.getFileStore(file.toPath());
    long usableSpace = fileStore.getUsableSpace();
    if (usableSpace < OUT_OF_DISK_THRESHOLD_BYTES) {
      throw new OutOfStorageSpaceException(fileStore.toString(),
          usableSpace, e);
    }
  }

  @Override
  public void close() throws IOException {
    writer.close();
  }

  @Override
  public void remove() throws IOException {
    this.file.delete();
  }

  /**
   * @return the number of bytes written to the buffer so far.
   */
  public long getBytesWritten() throws IOException {
    return counter.getCount();
  }

}
